<?php
// Mode: LT (for lab test, default) or FT (final exam)
// If mode == FT, submission files will be extracted from 
// an eLearn Quiz report (Attempt Details)
$mode = "FT";

// Exam details
$examShortName = trim(basename($root), " \n\t\t\0./");
$examLongName = "WAD Finals";

// eLearn Quiz report (Attempt Details) as CSV
$csvFileNamePattern = "$root/csv/IS113-$examShortName.csv";

// Rubric file: Ensure that its lines read like: (eg: see rubrics.csv)
// q14, 4, Auto-graded, q14/Olymbpics.php
// q14, -0.5, Syntax error, q14/Olymbpics.php
$rubricFile = "$root/rubric.csv";

// To reuse as much of the Grader as possible, in the "finals" mode,
// Grader will create zip files with the right names

// Folders where the eLearn Assignments (student zip files) are stored/created
// Use {sectionName} and {studentName} as placeholders, if needed
$submissionFolderPattern = "$root/submissions/";

// Will unzip the zip files to $answerFolderPattern/
$answerFolderPattern = "$root/answers/{studentName}/";

// Solutions and resources
$solutionFolder = "$root/solutions/";
$resourceFolder = "$root/resources/";

// LOCAL: Question number to be graded. Will populate $gradeQuestions with it.
$qNum = 14;
// Questions to grade as an array (so that the instructors can divide the labor)
$gradeQuestions = [$qNum]; // same as $qNum, but an array

// Autogradable question. 
// Key = File being autograded 
// Value = Array of files to be copied to the folder containing the autograded file
// The first one is expected to be the autograder, the rest helper files
$autoGrade = [
    "Olympics.php" => ["q14/autograder.php"]
];
/** AutoGrader options:
 *  The AutoGrader (meaning the value in $autoGrade above) should print 
 *  out a string that can be exploded using the subQuestion names below.
 *      $marker = "$subQuestionName: ";
 * For each subQuestion, a rubric should be defined in rubric.csv
 *      $rubricName = "$subQuestionName"; (for example)
 * so that the marks can be inserted into the database
 * and manual grading can be performed
 */
$autoGradeOptions = [
    'subQuestionNames' => ["q$qNum"]
];

// MySQL credentials: make $dbPass = ""; for WAMP
$dbUser = "root";
$dbPass = "root";
$dbName = "grader_test";
// No need to modify anything below this line
/* ============================================================ */
CFG::init();
HT::init();
