# Version 6.0

* [ ] In `AnswerDAO.php`, the `glob()` pattern for picking up student files should be dynamic: Use `nLevels =` Number of levels.
* [ ] In the update comment popup, give a list of comments already there in the DB for the file with the corresponding marks and allow user to select from the list.
  * [ ] Maybe comments by rubric?
* [X] Have another field in the `rubrics` table to hold the file name
  * [X] Highlight the filename in the file buttons
* [X] When student submissions are unpacked again, the existing comments (attached to each file), should not be overwritten.
* [ ] DAO refactoring: Base class `DAO` should contain `update()` method. Use [ReflectionClass](https://www.educba.com/php-reflection/) to get a list of properties, `toCamel()` and `toSnake()` (currently in `CFG.php` to be moved to `DAO.php`) for DB interactions. This is already done in the `Algo` package.
* [ ] Move all JavaScript code to `ui/js/utils.js`
* [ ] Audit private/public/protected methods. All dispatch handlers should be protected.
  * [ ] Document: PHPDoc strings everywhere
* [X] Quick Summary button in `Student::render()`: What does it do? If nothing, popup marks?
* [ ] Consider using sessions to persist the right frame upon updating marks. Make `$firstAnswer` session-bound.
* [ ] Test if submissions can be independent of Section Number
* [x] In the listing of resource (and solution) files, have a button to include/exclude from grading. Have another field in the `ref_files` table to hold this info. **Not needed: Already implemented by `RefFile::$gradable`**
* [ ] Standardize DB table names to singular
* [x] Version 5 includes code to (auto)grade Finals eLearn quiz. Not fully tested on Lab Test mode.
  * [x] Also test if the last line in the CSV file is read in properly
* [x] Have the exam folder (like LT1 or finals) at the same level as Grader so that PHP extensions don't get confused by a large number of files with same classes or functions.
* [x] `config.php` should `require_once` the config in the exam folder (rather than `ln -s`)
* [x] Create test/template folders  `LT0` and `FT0` with some test data (two sections, three students each), pointing to a DB `grader_test`
* [x] `setup.sql`is moved the exam folder (from the Grader folder)
* [x] DB validation now checks for the existence of tables like `CFG::dbPrefix_%`
* [x] Using LT (Lab Tests) and FT (finals) as `CFG::$mode`
* [ ] Audit Process Everything in `ui/process.php` for `CFG::$mode = FT` and `LT`
* [ ] Store all files (`ref_files` and `answers`) with respect to `DOCUMENT_ROOT`
  
