<?php
class Answer extends HT
{
	private $studentEmail;
	private $subQuestionName;
	private $fileName;
	private $fullText;
	private $hash0;
	private $hash1;
	private $comment;
	private $shortFileName;

	public function __construct(
		$studentEmail,
		$subQuestionName,
		$fileName,
		$fullText = '',
		$hash0 = '',
		$hash1 = '',
		$comment = ''
	) {
		$this->studentEmail = $studentEmail;
		$this->subQuestionName = $subQuestionName;
		$this->fileName = $fileName;
		if ($fullText) {
			$this->fullText = $fullText;
		} else {
			$this->fullText = file_get_contents($this->fileName);
		}
		if ($hash0) {
			$this->hash0 = $hash0;
		} else {
			$this->hash0 = Report::hash($this->fileName);
		}
		if ($hash1) {
			$this->hash1 = $hash1;
		} else {
			$this->hash1 = Report::hash($this->fileName, false);
		}
		$this->comment = $comment;
		$student = self::$studentDao->getByEmail($studentEmail)[0];
		$studentFolder = $student->getAnswerFolder();
		$this->shortFileName = trim(
			str_replace($studentFolder, "", $fileName),
			'/'
		);
	}
	private static function mkCommentPopup()
	{
		$file = "editComment";
		return "onclick=
        \"var h = screen.height * 0.3;
        var t = screen.height * 0.05;
        var w = screen.width * 0.25;
        var l = screen.width * 0.65;
        window.open('', '$file', 'width='+ w +',height=' + h + ',left='+ l +',top='+ t +',resizable=yes,scrollbars=yes,toolbar=yes,menubar=no,location=no,directories=no,status=yes'); 
          document.getElementById('$file').submit();
          return false;\"";
	}
	public function render($firstAnswer = "")
	{
		// var_dump($this); return;
		$subQuestionName = $this->subQuestionName;
		$exam = self::$exam;
		$gradable = false;
		// Grade the question only if it is in CFG::$gradeQuestions
		foreach ($exam->getQuestions() as $question) {
			if (in_array($question->getNum(), CFG::$gradeQuestions)) {
				foreach ($question->getSubQuestions() as $subQuestion) {
					if ($subQuestionName == $subQuestion->getName()) {
						$gradable = true;
						break 2;
					}
				}
			}
		}
		if (!$gradable) {
			return "";
		}
		$autoGraders = [];
		$autoFiles = [];
		static $autoDone = [];
		$student = self::$studentDao->getByObject($this)[0];
		// $submissionFolder = $student->getAnswerFolder();
		// foreach (CFG::$autoGrade as $grader => $files) {
		// 	$autoGrader = $submissionFolder . $grader;
		// 	$autoGraders[] = $autoGrader;
		// 	$autoFiles = array_merge($autoFiles, $files);
		// }

		$answerFolder = $student->getAnswerFolder();
		foreach (CFG::$autoGrade as $answerFile => $graders) {
			// CFG::$autoGrade is an assoc array: $answerFile => [$autoGrader, helpers]
			// The first element in the autograder
			$autoGrader = $graders[0];
			$autoGraders[] = $answerFolder . $autoGrader;
			$autoFiles[] = $answerFile;
		}

		$fileName = $this->fileName;
		$shortFileName = $this->shortFileName;
		$basename = basename($fileName);
		if (!self::$refFileDao->isGradable($shortFileName)) {
			return "";
		}
		$fullText = htmlentities($this->fullText, ENT_QUOTES);
		$popup = htmlentities(self::mkCommentPopup(), ENT_QUOTES);
		$td = "";
		$tdFileDB = "<td align='center'> 
		<form method='post' action='?do' target='right2'>
		<input type='submit' $firstAnswer name='viewfile' 
		title='$fileName' value='$basename: DB' > 
		<input type='hidden' name='do' value='viewFile'>
		<input type='hidden' name='student_email' value='$this->studentEmail'>
		<input type='hidden' name='subquestion_name' 
		value='$subQuestionName'>
		<input type='hidden' name='filename' value='$fileName'>
		<input type='hidden' name='showDB' value='Yes'>
		<input type='hidden' name='fulltext' value='$fullText'>
		</form></td>
		";
		$tdFileHDD = "<td align='center'> 
		<form method='post' action='?do' target='right2'>
		<input type='submit' $firstAnswer name='viewfile' 
		title='$fileName' value='$basename' > 
		<input type='hidden' name='do' value='viewFile'>
		<input type='hidden' name='commentable' value='$fileName'>
		<input type='hidden' name='popup' value='$popup'>
		<input type='hidden' name='student_email' value='$this->studentEmail'>
		<input type='hidden' name='subquestion_name' 
		value='$subQuestionName'>
		<input type='hidden' name='filename' value='$fileName'>
		<input type='hidden' name='fulltext' value='$fullText'>
		</form></td>
		";
		if (in_array($basename, $autoFiles)) {
			foreach ($autoGraders as $autoGrader) {
				if (!in_array($autoGrader, $autoDone)) {
					$autoDone[] = $autoGrader;
					$graderURL = str_replace(realpath($_SERVER['DOCUMENT_ROOT']), "", $autoGrader);
					$td .= "<td align='center'>
			<a href='$graderURL' target='right2'><input type='button' 
			$firstAnswer value='$subQuestionName: Auto Grade'></a></td>";
					break;
				}
			}
			if (CFG::isQuiz()) {
				$td .= $tdFileDB . $tdFileHDD;
			}
		} else {
			$td .= $tdFileHDD;
		}
		return $td;
	}
	/**
	 * @return mixed
	 */
	public function getStudentEmail()
	{
		return $this->studentEmail;
	}
	/**
	 * @return mixed
	 */
	public function getSubQuestionName()
	{
		return $this->subQuestionName;
	}
	/**
	 * @return mixed
	 */
	public function getFullText()
	{
		return $this->fullText;
	}
	/**
	 * @return mixed
	 */
	public function getFileName()
	{
		return $this->fileName;
	}
	/**
	 * @return mixed
	 */
	public function getComment()
	{
		return $this->comment;
	}
	/**
	 * @param mixed $comment 
	 * @return self
	 */
	public function setComment($comment): self
	{
		$this->comment = $comment;
		return $this;
	}

	/**
	 * @return mixed
	 */
	public function getHash0()
	{
		return $this->hash0;
	}
	/**
	 * @return mixed
	 */
	public function getHash1()
	{
		return $this->hash1;
	}

	/**
	 * @return mixed
	 */
	public function getShortFileName()
	{
		return $this->shortFileName;
	}
}
