<?php
/**
 * Summary of MarksDAO
 */
class MarksDAO
{
    private static $table;
    public function __construct()
    {
        $table = CFG::mkTableName("marks");
        self::$table = $table;
    }
    public function get($where = [])
    {
        $table = self::$table;
        $rows = DB::$db->get(
            table: $table,
            where: $where
        );
        $marks = [];
        foreach ($rows as $row) {
            $marks[] = new Marks(
                $row['student_email'],
                $row['subquestion_name'],
                $row['rubric_name'],
                $row['marks']
            );
        }
        return $marks;
    }
    public function getByObject($student, $subQuestion = null, $rubric = null)
    {
        $where = ['student_email' => $student->getEmail()];
        if ($subQuestion) {
            $where['subquestion_name'] = $subQuestion->getName();
        }
        if ($rubric) {
            $where['rubric_name'] = $rubric->getRubricName();
        }
        return $this->get($where);
    }
    public function update($marks)
    {
        $table = self::$table;
        $studentEmail = $marks->getStudentEmail();
        $subQuestionName = $marks->getSubQuestionName();
        $rubricName = $marks->getRubricName();
        $studentMarks = $marks->getMarks();
        $columns = ['student_email', 'subquestion_name', 'rubric_name', 'marks'];
        $row = [$studentEmail, $subQuestionName, $rubricName, $studentMarks];
        // DB::$db->put($table, $columns, $row);
        DB::$db->update($table, $columns, $row);
    }
}