<?php
// May not use this class
class QuestionDAO
{
    private static $table;
    public function __construct()
    {
        $table = CFG::mkTableName("questions");
        self::$table = $table;
    }
    public function get($where = [], $verbose=false)
    {
        $table = self::$table;
        $rows = DB::$db->get(
        table: $table,
        where: $where
        );
        $got = count($rows);
        if ($verbose && $got <= 0) { // Not found in the DB
            HT::error("<strong>AnswerDAO</strong>: 
                No answers in the DB!<br>
                Run AnswerDAO->process(student) for each student first.");
            return;
        } else {
            $questions = [];
            foreach ($rows as $row) {
                $questions[] = new Question(
                    $row['question_num'],
                    $row['marks']
                );
            }
        }
        // Drop the questions not in the gradable list
        foreach ($questions as $key => $question){
            if (!in_array($question->getNum(), CFG::$gradeQuestions)) {
                unset($questions[$key]);
            }
        }
        return $questions;
    }
    public function put($questions)
    {
        $table = self::$table;
        $rows = [];
        foreach ($questions as $question) {
            $num = $question->getNum();
            $marks = $question->getMarks();
            $columns = ['question_num', 'marks'];
            $rows[] = [$num, $marks];
        }
        // DB::$db->put($table, $columns, $rows);
        DB::$db->update($table, $columns, $rows);
    }
    public function process()
    {
        if (CFG::isQuiz()) {
            // Done in Exam.php already.
            return;
        }
        // Section Names
        $secNames = CFG::$sectionNames;
        // Locations of subquestion number and marks in the CSV file header
        $locSubQ = CFG::$locSubQ;
        $locMarks = CFG::$locMarks;
        // From the header row of the given CSV file (eLearn grade export),
        // construct the question and its subquestions
        // $csv = "./CSV/IS113-LT1-{$secNames[0]}.csv";
        $csv = CFG::getCsvFileName($secNames[0]);
        if (!is_file($csv)) {
            HT::error("Error loading $csv");
            return;
        }
        $file = fopen($csv, 'r');
        $headers = fgetcsv($file);
        fclose($file);
        // Filter only the questions column headers
        foreach ($headers as $key => $value) {
            if (empty($value) || (preg_match('@[qQ].[A-Za-z]@', $value) == 0)) {
                unset($headers[$key]);
            }
        }
        // Get the marks for each subquestion and question numbers
        $marks = $questionNum = [];
        foreach ($headers as $key => $value) {
            $tokens = explode(" ", $value);
            $subQuestionName = strtolower(trim($tokens[$locSubQ]));
            $marks[$subQuestionName] = explode(":", $tokens[$locMarks])[1];
            // Use preg_match() function to check match
            preg_match('!\d+!', $subQuestionName, $match);
            if (!in_array($match[0], $questionNum)) {
                $questionNum[] = $match[0];
            }
        }
        // We now have question numbers, subquestion names and marks
        $questions = [];
        foreach ($questionNum as $num) {
            $questions[] = new Question($num, $marks);
        }
        $this->put($questions);
    }
}