<?php
// May not use this class
class SubQuestionDAO
{
    private static $table;
    public function __construct()
    {
        self::$table = CFG::mkTableName("subquestions");
    }
    public function get($where = [], $verbose = false)
    {
        $table = self::$table;
        $subQuestions = [];
        $rows = DB::$db->get(
            table: $table,
            where: $where
        );
        $got = count($rows);
        if ($verbose && $got <= 0) { // Not found in the DB
            HT::error("<strong>SubQuestionDAO</strong>: 
            No subQuestions in the DB!<br>
            Run SubQuestionDAO->process(question) for each question first.");
            return;
        } else {
            foreach ($rows as $row) {
                $subQuestions[] = new SubQuestion(
                    $row['subquestion_name'],
                    $row['marks'],
                    $row['question_num']
                );
            }
        }
        return $subQuestions;
    }
    public function put($subQuestions)
    {
        $table = self::$table;
        $rows = [];
        foreach ($subQuestions as $subQuestion) {
            $subQuestionName = $subQuestion->getName();
            $questionNum = $subQuestion->getQuestionNum();
            $marks = $subQuestion->getMarks();
            $columns = ['subquestion_name', 'question_num', 'marks'];
            $rows[] = [$subQuestionName, $questionNum, $marks];
        }
        // DB::$db->put($table, $columns, $rows);
        DB::$db->update($table, $columns, $rows);
    }
    public function process($question)
    {
        $subQuestions = $question->getSubQuestions();
        $this->put($subQuestions);
    }
}