<?php
class RefFile
{
    private $subQuestionName;
    private $fileType;
    private $fileName;
    private $fullText;
    private $hash0;
    private $hash1;
    private $sim;
    private $gradable = false;
    private $shortFileName;
    
    public function __construct(
        $subQuestionName,
        $fileType,
        $fileName,
        $fullText = '',
        $hash0 = '',
        $hash1 = ''
    ) {
        $this->subQuestionName = $subQuestionName;
        $this->fileType = $fileType;
        $this->fileName = $fileName;
        if (empty($fullText)) {
            $fullText = DB::$db->getFileContent($fileName);
        }
        $this->fullText = $fullText;
        if (empty($hash0)) {
            $hash0 = Report::hash($fileName);
        }
        $this->hash0 = $hash0;
        if (empty($hash1)) {
            $hash1 = Report::hash($fileName, true);
        }
        $this->hash1 = $hash1;
        $folders = [
            'resources' => CFG::$resourceFolder,
            'solutions' => CFG::$solutionFolder,
        ];
		$this->shortFileName = trim(
			str_ireplace($folders[$fileType], "", $fileName),
			'/'
		);
    }
    /**
     * @return mixed
     */
    public function getSubQuestionName()
    {
        return $this->subQuestionName;
    }
    /**
     * @return mixed
     */
    public function getFullText()
    {
        return $this->fullText;
    }
    /**
     * @return mixed
     */
    public function getFileType()
    {
        return $this->fileType;
    }
    /**
     * @return mixed
     */
    public function getFileName()
    {
        return $this->fileName;
    }
    /**
     * @return mixed
     */
    public function getHash0()
    {
        return $this->hash0;
    }
    /**
     * @return mixed
     */
    public function getHash1()
    {
        return $this->hash1;
    }

	/**
	 * @param mixed $gradable 
	 * @return self
	 */
	public function setGradable($gradable): self {
		$this->gradable = $gradable;
		return $this;
	}

	/**
	 * @return mixed
	 */
	public function isGradable() {
		return $this->gradable;
	}

	/**
	 * @return mixed
	 */
	public function getShortFileName() {
		return $this->shortFileName;
	}

	/**
	 * @param mixed $gradable 
	 * @return self
	 */
	public function setSim($sim): self {
		$this->sim = $sim;
		return $this;
	}
	/**
	 * @return mixed
	 */
	public function getSim() {
		return $this->sim;
	}
}