<?php
class Student extends HT
{
    private $email;
    private $name;
    private $section;
    private $zipFile;
    private $status = "New";
    private $comment = "";
    public function __construct($email, $name, $section)
    {
        $this->email = trim(trim($email), "#");
        $this->name = $name;
        $this->section = $section;
    }
    // The rest of the methods are for grading. Maybe time to create another
    // class Answer {} and inject an array of answers into Student?
    public function getAnswerFolder()
    {
        $sectionName = $this->section;
        $studentName = $this->name;
        $answerFolder = CFG::getAnswerFolder($sectionName, $studentName);
        return $answerFolder;
    }
    public function render()
    {
        list($prev, $prevUngraded, $nextUngraded, $next)
            = self::$studentDao->getOthers($this);
        $srcDoc = HT::head(true);
        $prevForm =
            $prevUngradedForm =
            $nextForm =
            $nextUngradedForm = "<td style='width:1%'></td>";
        $clearRight = "onclick='var right1 = window.parent.parent.right.right1; 
        right1.document.write(); var right2 = window.parent.parent.right.right2;
        right2.document.write();'";
        if ($prev) {
            $prevForm = "<td style='width:1%'>
            <form method='post' target='left' action='?do'>
            <input type='hidden' name='do' value='gradeOne'>
            <input type='hidden' name='email' value='$prev->email'>
            <input type='submit' value='Prev' title='$prev->name' $clearRight >
            </form></td>";
        }
        if ($prevUngraded) {
            $prevUngradedForm = "<td style='width:1%'>
            <form method='post' target='left' action='?do'>
            <input type='hidden' name='do' value='gradeOne'>
            <input type='hidden' name='email' value='$prevUngraded->email'>
            <input type='submit' value='Prev Ungraded' 
            title='$prevUngraded->name' $clearRight>
            </form></td>";
        }
        if ($next) {
            $nextForm = "<td style='width:1%'>
            <form method='post' target='left' action='?do'>
            <input type='hidden' name='do' value='gradeOne' >
            <input type='hidden' name='email' value='$next->email'>
            <input type='submit' value='Next' title='$next->name' $clearRight>
            </form></td>";
        }
        if ($nextUngraded) {
            $nextUngradedForm = "<td style='width:1%'>
            <form method='post' target='left' action='?do'>
            <input type='hidden' name='do' value='gradeOne'>
            <input type='hidden' name='email' value='$nextUngraded->email'>
            <input type='submit' value='Next Ungraded' 
            title='$nextUngraded->name' $clearRight>
            </form></td>";
        }
        $nStudents = self::$studentDao->getNStudents();
        $iStudent = self::$studentDao->getIStudent($this->email);
        $srcDoc .= HT::info("<div style='text-align:center;font-size:120%;'>
        <table align='center' style='width:100%'><tr>$prevForm $prevUngradedForm 
        <td><strong title='Student::render()'>$this->name</strong>&emsp;
        <small style='font-size:80%;'> [<strong>$this->section</strong>: 
        $iStudent of $nStudents]</small></td>
        $nextUngradedForm $nextForm </tr></table></div>
        <table align='center'><tr>
        <td><form method='post' target='left' id='reload' action='?do'>
        <input type='submit' value='Reload'>
        <input type='hidden' name='do' value='gradeOne'>
        <input type='hidden' name='name' value='$this->name'>
        <input type='hidden' name='email' value='$this->email'>
        </form></td>
        <td><form method='post' target='right' action='?do'>       
        <input type='submit' id='loadAnswers' value='Show Answers'>
        <input type='hidden' name='do' value='loadAnswers'>
        <input type='hidden' name='name' value='$this->name'>
        <input type='hidden' name='email' value='$this->email'>
        </form></td>
        <td><form method='post' target='right2' action='?do'>       
        <input type='submit' name='summary' value='Quick Summary'>
        <input type='hidden' name='do' value='quickSummary'>
        <input type='hidden' name='name' value='$this->name'>
        <input type='hidden' name='email' value='$this->email'>
        </form></td>
        </tr></table>
        ", true);
        $loadAnswers = "<script type='text/javascript'> 
        window.onload=function(){document.getElementById('loadAnswers').click();} 
        </script>";
        $srcDoc .= $loadAnswers;
        $srcDoc .= HT::foot(true);
        return $srcDoc;
    }
    private function sumMarks()
    {
        $marksAll = self::$marksDao->getByObject($this);
        $total = 0;
        foreach ($marksAll as $marks) {
            $total += $marks->getMarks();
        }
        return $total;
    }
    public function sumMarksBySubQuestion()
    {
        $sums = [];
        foreach (self::$exam->getQuestions() as $question) {
            $subQuestions = $question->getSubquestions();
            foreach ($subQuestions as $subQuestion) {
                $marks = self::$marksDao->getByObject($this, $subQuestion);
                $subQuestionName = $subQuestion->getName();
                foreach ($marks as $m) {
                    if (isset($sums[$subQuestionName])) {
                        $sums[$subQuestionName] += $m->getMarks();
                    } else {
                        $sums[$subQuestionName] = $m->getMarks();
                    }
                }
            }
        }
        return $sums;
    }
    public function mkLeadIn()
    {
        $leadIn = "<strong>$this->name</strong> [$this->section]: ";
        return $leadIn;
    }
    public function getMessage()
    {
        $marksAll = self::$marksDao->getByObject($this);
        $total = $this->sumMarks();
        $rubricTotal = 0;
        $rubricsAll = [];
        foreach (self::$exam->getQuestions() as $question) {
            $subQuestions = $question->getSubquestions();
            foreach ($subQuestions as $subQuestion) {
                $rubrics = self::$rubricDao->getByObject($subQuestion);
                foreach ($rubrics as $rubric) {
                    $rubricMark = $rubric->getMarks();
                    $rubricsAll[] = $rubric;
                    if ($rubricMark > 0) {
                        $rubricTotal += $rubricMark;
                    }
                }
            }
        }
        $numMarks = count($marksAll);
        $numRubrics = count($rubricsAll);
        if ($numMarks == $numRubrics) {
            $this->setStatus("Graded")->update();
            $msg = "[Grading Complete:  Marks: $total/$rubricTotal]";
        } else if (count($marksAll) > 0) {
            $this->setStatus("Grading")->update();
            $msg = "[Grading in Progress:  Marks: $total/$rubricTotal ($numMarks of $numRubrics rubrics done)]";
        } else {
            $msg = "";
        }
        $this->sumMarksBySubQuestion();
        return $msg;
    }
    public function grade()
    {
        $msg = $this->getMessage();
        $echo = "info";
        $what = "";
        $disabled = "";
        if ($this->status == "Absent") {
            $value = "Ignore";
            $echo = "error";
            $disabled = "disabled";
        } else if ($this->status == "Grading") {
            $value = "Continue";
            $echo = ($this->sumMarks() > 0) ? "warn" : "plain";
        } elseif ($this->status == "Graded") {
            $value = "Regrade";
            $echo = "success";
        } else {
            $value = "Grade";
            $echo = "info";
        }
        $nStudents = self::$studentDao->getNStudents();
        $iStudent = self::$studentDao->getIStudent($this->email);
        $what = "<strong>$this->name</strong>&emsp;<small>$msg&emsp;
            ($iStudent of " . $nStudents . ")</small>
        <form method='post'  target='left'>
        <input type='submit' name='gradeOne' value='$value' $disabled
        style='position:absolute;top:10px;right:20px;'>
        <input type='hidden' name='do' value='gradeOne'>
        <input type='hidden' name='email' value='$this->email'>
        </form>";
        $this->$echo($what);
    }
    public function delete($name = '')
    {
        $submissionFolder = realpath($this->getAnswerFolder());
        CFG::rmdir($submissionFolder);
        HT::warn("<strong>$this->name</strong>: Deleted unzipped files in <br>
        <code>$submissionFolder</code>");
    }
    public function update()
    {
        self::$studentDao->update($this);
    }
    public function getEmail()
    {
        return $this->email;
    }
    public function getSection()
    {
        return $this->section;
    }
    public function getStatus()
    {
        return $this->status;
    }
    public function print($toStr = true)
    {
        $str = parent::print($toStr);
        return $str;
    }
    /**
     * Autograde a question with multiple subparts 
     * @return [type]
     */
    public function autoGrade()
    {
        if ($this->status == 'Absent') {
            return;
        }
        $options = CFG::$autoGradeOptions;
        $subQuestionNames = $options['subQuestionNames'];
        $autoGrade = CFG::$autoGrade;
        $autoGrader = array_pop($autoGrade)[0];
        $autoGrader = realpath($this->getAnswerFolder() . $autoGrader);
        
        // This snippet doesn't work because urlencode is too aggressive
        // $autoGrader = str_replace($_SERVER['DOCUMENT_ROOT'], '', $autoGrader);
        // $autoGrader = urlencode($autoGrader);
        // $url = "http://localhost" . $autoGrader;

        // Just replace the spaces for now
        $url0 = str_replace(realpath($_SERVER['DOCUMENT_ROOT']), "http://localhost", $autoGrader);
        $url = str_replace(' ', '%20', $url0);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        // In case there are infinite loops in the student code, timeout in 15 seconds
        // Fatal errors also seem to hang the CURL connection
        curl_setopt($ch, CURLOPT_TIMEOUT, 5);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $output = curl_exec($ch);
        curl_close($ch);
        $leadIn = $this->mkLeadIn();
        foreach ($subQuestionNames as $subQuestionName) {
            $marker = "$subQuestionName: ";
            $rubricName = "$subQuestionName-1";
            $lines = explode($marker, $output);
            // Mark is the first token in $line[1]
            $mark = 0;
            if (isset($lines[1])) {
                $mark = floatval($lines[1]);
                // str_pad is to bust out of output buffering
                if ($mark > 0) {
                    HT::warn(str_pad("$leadIn: $mark", 4096));
                } else {
                    HT::error(str_pad("$leadIn: $mark", 4096));
                }
            } else {
                HT::error("$leadIn: Cannot run auto-grader [Question: $subQuestionName]
            <table align='right'><tr>
            <td><a href='$url' target='right'><button>Open it</button></a></td>
            <td><form method='post' target='left'>
            <input type='submit' name='gradeOne' value='Grade'>
            <input type='hidden' name='do' value='gradeOne'>
            <input type='hidden' name='email' value='$this->email'>
            </form></td>
            </tr></table>");
            }
            $marksObj = new Marks($this->email, $subQuestionName, $rubricName, $mark);
            self::$marksDao->update($marksObj);
            $this->setComment(htmlentities($output));
            self::$studentDao->update($this);
        }
    }
    /**
     * Autograde a single question with a single rubric.
     * Deprecated
     * @return [type]
     */
    public function autoGrade1()
    {
        if ($this->status == 'Absent') {
            return;
        }
        $options = CFG::$autoGradeOptions;
        $marker = $options['outputMarker'];
        $subQuestionName = $options['subQuestionNames'];
        $rubricName = $options['rubricName'];
        $autoGrader = $this->getAnswerFolder() . "/" .
            array_keys(CFG::$autoGrade)[0];
        $url0 = str_replace("..", "http://localhost" . CFG::$graderPath, $autoGrader);
        $url = str_replace(' ', '%20', $url0);
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_HEADER, 0);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $output = curl_exec($ch);
        curl_close($ch);
        $leadIn = $this->mkLeadIn();
        $lines = explode($marker, $output);
        // Mark is the first char in $line[1]
        $mark = 0;
        if (isset($lines[1])) {
            $mark = $lines[1][0];
            if ($mark > 0) {
                HT::warn("$leadIn: $mark");
            }
        } else {
            HT::error("$leadIn: Cannot run auto-grader
            <table align='right'><tr>
            <td><a href='$url' target='right'><button>Open it</button></a></td>
            <td><form method='post' target='left'>
            <input type='submit' name='gradeOne' value='Grade'>
            <input type='hidden' name='do' value='gradeOne'>
            <input type='hidden' name='email' value='$this->email'>
            </form></td>
            </tr></table>");
        }
        $marksObj = new Marks($this->email, $subQuestionName, $rubricName, $mark);
        self::$marksDao->update($marksObj);
    }
    /**
     * @return mixed
     */
    public function getZipFile()
    {
        return $this->zipFile;
    }
    /**
     * @return mixed
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * @param mixed $zipFile 
     * @return self
     */
    public function setZipFile($zipFile): self
    {
        $this->zipFile = $zipFile;
        return $this;
    }
    /**
     * @return mixed
     */
    public function getComment()
    {
        return $this->comment;
    }
    /**
     * @param mixed $comment 
     * @return self
     */
    public function setComment($comment): self
    {
        $this->comment = $comment;
        return $this;
    }
    /**
     * @param mixed $status 
     * @return self
     */
    public function setStatus($status): self
    {
        $this->status = $status;
        return $this;
    }
    public function csv()
    {
        $str = "<tr><td>$this->name</td>";
        $marks = $this->sumMarksBySubQuestion();
        foreach ($marks as $subQuestionName => $m) {
            $str .= "<td>$subQuestionName &rarr; $m</td>";
        }
        $str .= "</tr>";
        return $str;
    }
}
