<?php
spl_autoload_register(
    function ($class) {
        $folders = [
            "model",
            "model/DAO",
            "../model",
            "../model/DAO",
            "../../model",
            "../../model/DAO"
        ];
        foreach ($folders as $folder) {
            $file = "$folder/$class.php";
            if (file_exists($file)) {
                require_once($file);
                $return;
            }
        }
    }
);
// So that I don't have to remember the names:
// global $dbg; $dbg();
$dbg = "xdebug_print_function_stack";
$vd = "var_dump";
/**
 * Stack trace from XDebug
 * @return void
 */
function dbg()
{
    global $dbg;
    if (function_exists($dbg)) {
        $dbg("Stack Trace", XDEBUG_STACK_NO_DESC);
    } else {
        debug_backtrace();
    }
}

/**
 * An alias for var_dump
 * @param array $args
 * @return void
 */
function vd(...$args)
{
    var_dump(...$args);
}