<?php
// Mode: LT (for lab test, default) or FT (final exam)
// If mode == FT, submission files will be extracted from 
// an eLearn Quiz report (Attempt Details)
$mode = "LT";

// Exam details
$examShortName = trim(basename($root), " \n\t\t\0./");
$examLongName = "WAD Lab Test 2";

// Your sections
$sectionNames = ["G1", "G6", "G7"];

// Files where the eLearn Grade exports are stored
$csvFileNamePattern = "$root/csv/IS113-$examShortName-{sectionName}.csv";

// Location of subQuestion number and marks in the CSV file header
// Example:
//  LT1 Q1A Points Grade <Numeric MaxPoints:2 Weight:10 Category:Lab Test 1 CategoryWeight:20>
//    $subQuestionName = strtolower(trim($tokens[$locSubQ]));
//    $marks[$subQuestionName] = explode(":", $tokens[$locMarks])[1];
$locSubQ = 1;
$locMarks = 5;

// Rubric file: Ensure that its lines read like:
// "Q1A, 0.50, "Use of <h1></h1> for displaying the title."
// with the first column matching the grade items in the $csvFileNamePattern
$rubricFile = "$root/rubric.csv";

// Folders where the eLearn Assignments (student zip files) are stored/created
// Use {sectionName} and {studentName} as placeholders, if needed
$submissionFolderPattern = "$root/submissions/{sectionName}/";

// Will unzip the zip files to $answerFolderPattern/
$answerFolderPattern = "$root/answers/{sectionName}/{studentName}/";

// Folders where the emailed zip files are stored
$emailFolder = "$root/submissions/emails/";

// Solutions and resources
$solutionFolder = "$root/solutions/";
$resourceFolder = "$root/resources/";

// Questions to grade as an array (so that the instructors can divide the labor)
$gradeQuestions = [1, 2, 3];

// Autogradable question. 
// Key = File being autograded 
// Value = Array of files to be copied to the folder containing the autograded file
// The first one is expected to be the autograder, the rest helper files
$autoGrade = [
    "q3.php" => ["q3/q3-autograder.php", 'q3/lt2_q3_data/tour_data.csv']
];
/** AutoGrader options:
 *  AutoGrader (meaning the value in $autoGrade above) should print out
 *  a string that can be exploded using the subQuestion names below.
 *      $marker = "$subQuestionName: ";
 * For each subQuestion, a rubric should be defined in rubric.csv
 *      $rubricName = "$subQuestionName-1";
 * so that the marks can be inserted into the database
 * and manual grading can be performed
 */
$autoGradeOptions = [
    'subQuestionNames' => ['q3']
];

// MySQL credentials: make $dbPass = ""; for WAMP
$dbUser = "root";
$dbPass = "root";
$dbName = "grader_test";
// No need to modify anything below this line
/* ============================================================ */
CFG::init();
HT::init();