<?php

/*
    Name: 
    Email:
*/

require_once "autoload.php";
?>
<html>

<head>
    <title>
        Login to the Library
    </title>
</head>

<body>

    <?php
    date_default_timezone_set("Singapore");
    $hourOfTheDay = date('H');

    // To test your code. Comment out before submitting.
    // $hourOfTheDay = 6;

    // ADD YOUR CODE STARTING HERE
    
    // Hints/Logic:
    // If the hour of the day outside the opening hours, show a message.
    // Else, if the user is already logged in, redirect the user based on his role.
    // Else, if the login form is not submitted, display the form to login.
    // Else, authenticate the user.
    //    If authentication succeeds, redirect the user based on his role.
    //        Else, if the registration is in inactive mode, ask to get confirmed.
    //        Else, say that registration has been rejected. 
    //    Else, ask the user to get registered.
    
    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.
    
    // SOLUTION: REMOVE IN RESOURCES

    // Part B (4 marks): login.php
    // session_start() called -> 0.25
    // The hourOfTheDay = 6 checked correctly -> 0.25 
    // Checking of the user is logged in -> 0.5
    // Redirecting header("Location: $role-page.php") if logged in -> 0.25
    // Displaying the form only if not submitted -> 0.75
    // Authenticating the user -> 0.25
    // Setting the session variables for user and role -> 0.5
    // Redirecting header("Location: $role-page.php") ->0.25
    // Correct Registration Pending message -> 0.25
    // Correct Registration Failed message -> 0.25
    // Correct Authentication Failed message -> 0.5
    if (!isset($_SESSION)) {
        session_start();
    }
    if ($hourOfTheDay < 8 || $hourOfTheDay >= 19) {
        echo "<h2>Sorry, the library is closed now.</h2><hr>";
    } else if (isset($_SESSION["username"]) && isset($_SESSION["role"])) { // already logged in
        $username = $_SESSION["username"];
        $role = $_SESSION["role"];
        // Redirect to a home page or dashboard based on role
        header("Location: $role-page.php");
    } else if (empty($_POST)) {// User is not logged in. Display a form to log in.
        ?>
                <h2>Please Login</h2>
                <form method="post">
                    <table border="1">
                        <tr>
                            <td>User Name:</td>
                            <td><input type="text" name="username"></td>
                        </tr>
                        <tr>
                            <td>Password:</td>
                            <td><input type="password" name="password"></td>
                        </tr>
                        <tr>
                            <td></td>
                            <td><input type="submit"></td>
                        </tr>
                    </table>
                </form>
        <?php
    } else { // User is trying to login.
        $username = $_POST['username'];
        $password = $_POST['password'];

        $userDAO = new UserDAO();

        $user = $userDAO->authenticateUser($username, $password);

        if ($user != null) {
            $status = $user->getStatus();
            if ($status == 'active') {
                $role = $user->getRole();
                $_SESSION['username'] = $user->getUsername();
                $_SESSION['role'] = $role;
                // Redirect to a home page or dashboard based on role
                header("Location: $role-page.php");
            } else if ($status == "new") {
                echo "<h2>Registration Pending</h2>
                    <hr>Please wait for your registration to be approved.";
            } else if ($status == "inactive") {
                echo "<h2>Registration Failed</h2>
                    <hr>You are not allowed to use this library.";
            }
        } else { // Authentication failed
            echo "<h2>Authentication Failure</h2>
        <hr>Please check your username and/or password.<br>
        If you are not a registered user, please 
        <a href='register.php'>register</a>.";
        }
    }

    // END OF YOUR CODE
    ?>
</body>

</html>