<?php

/*
    Name: 
    Email:
*/

require_once "autoload.php";
if (!isset($_SESSION)) {
    session_start();
}
?>
<html>

<head>
    <title>
        Register to the Library
    </title>
</head>

<body>

    <?php
    // ADD YOUR CODE STARTING HERE
    
    // Hints/Logic:
    // If already logged in, show a message (Test 1, page #12) and do nothing.
    //  [You can use the php statement "return;" to exit from this file.]
    // Else, validate the username and password as described in the question.
    /*  [You may be able to copy and paste this:
            <p>Please use your email ID as the username.</p>
            <p>Password Policy: 8 to 12 characters.<br>
            At least one UPPERCASE, one lowercase letter and one digit.</p>
        ] */
    // Consider the functions strpos(), strlen(), ctype_upper(),
    // ctype_lower(), ctype_digit() to validate username/password.
    // If validation fails, show the form with appropriate error messages.
    // Or, if the registration form is not submitted, display the form.
    // If validation succeeds, 
    //   insert in the database with role = 'user' and status = 'new'.
    
    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.
    
    // SOLUTION: REMOVE IN RESOURCES
    
    // Part D (4 marks): register.php
    // Test 1: Registration status checked using session variables -> 0.5
    // Test 1: Message shown with the right link to logout -> 0.25
    // Test 2: Register form displayed with empty rows only when not submitted -> 0.5
    // Test 3: Empty form submission: All error messages displayed -> 0.5
    // Test 4: Form displayed again with values persisted -> 0.25
    // Test 4: Number of characters in the password counted -> 0.25
    // Test 4: Form displayed again with values persisted -> 0.25
    // Test 5: Email validity check -> 0.25
    // Test 6: Password validity check -> 0.25
    // Test 7: Email validity check again -> 0.25
    // Test 7: Password validity check again: Too many characters -> 0.25
    // Test 8: Registration successful message -> 0.25
    // Test 9: Registration failure message -> 0.25
    // Ignore display errors, and wording errors in error messages as long as the
    // meaning is clear enough.
    
    $errorU = $errorP = $username = $password = "";
    $showForm = true;
    if (isset($_SESSION["username"]) && isset($_SESSION["role"])) { // already logged in
        $username = $_SESSION["username"];
        $role = $_SESSION["role"];
        echo "<h4>User: $username already logged in as $role.</h4>
        Please <a href='logout.php'>logout from the Library</a> before registering.<hr>";
        return;
    } else if (!empty($_POST)) {// Something posted. Validate username and password
        $username = $_POST['username'];
        $password = $_POST['password'];

        if (empty($username)) {
            $errorU .= "Username is required.<br>";
        }
        if (empty($password)) {
            $errorP .= "Password is required.<br>";
        }
        $atPos = strpos($username, "@");
        if ($atPos == false || strpos($username, ".", $atPos) === false) {
            // @ not found, or found at the beginning
            // OR . not found after @
            $errorU .= "Username needs to be a valid email.<br>";
        }
        $gotLower = $gotUpper = $gotDigit = false;
        $passwordLen = strlen($password);
        if ($passwordLen < 8 || $passwordLen > 12) {
            $errorP .= "Error in password length ($passwordLen): 
            At least 8, at most 12 characters.<br>";
        }
        for ($i = 0; $i < $passwordLen; $i++) {
            $c = $password[$i];
            if (ctype_lower($c)) {
                $gotLower = true;
            }
            if (ctype_upper($c)) {
                $gotUpper = true;
            }
            if (ctype_digit($c)) {
                $gotDigit = true;
            }
        }
        if (!$gotLower) {
            $errorP .= "Password requires at least one lowercase letter.<br>";
        }
        if (!$gotUpper) {
            $errorP .= "Password requires at least one UPPERCASE letter.<br>";
        }
        if (!$gotDigit) {
            $errorP .= "Password requires at least one digit.<br>";
        }
        $showForm = !empty($errorP . $errorU);
    }
    if ($showForm) {// Display a form to register.
        ?>
        <h2>Please Register</h2>
        <form method="post">
            <table border="1">
                <tr>
                    <td>User Name:</td>
                    <td><input type="text" name="username" value='<?= $username ?>'></td>
                </tr>
                <tr>
                    <td colspan="2">
                        <?= $errorU ?>
                    </td>
                </tr>
                <tr>
                    <td>Password:</td>
                    <td><input type="password" name="password" value='<?= $password ?>'></td>
                </tr>
                <tr>
                    <td colspan="2">
                        <?= $errorP ?>
                    </td>
                </tr>
                <tr>
                    <td></td>
                    <td><input type="submit"></td>
                </tr>
            </table>
        </form>
        <p>Please use your email ID as the username.</p>
        <p>Password Policy: 8 to 12 characters.<br>
            At least one UPPERCASE, one lowercase letter and one digit.</p>
    <?php } else { // All good. Insert in the database
    
        $userDAO = new UserDAO();
        $isAddOK = $userDAO->addUser($username, $password);
        if ($isAddOK) {
            echo "Registration requested. Please wait!";
        } else {
            echo "Error adding $username!";
        }
    }

    // END OF YOUR CODE
    ?>
</body>

</html>