<?php
session_start();
/*
    Name: STUDENT FIVE
    Email: student.five.2023
*/

require_once "autoload.php";
?>
<html>

<head>
    <title>
        Login to the Library
    </title>
</head>

<body>

    <?php
    date_default_timezone_set("Singapore");
    $hourOfTheDay = date('H');
    // To test your code. Comment out before submitting.
    // $hourOfTheDay = 6;

    // ADD YOUR CODE STARTING HERE
    if ($hourOfTheDay < 8 || $hourOfTheDay > 19) {
        echo "<h2>Sorry, the library is closed now. <hr>";
    } else {
        if (isset($_SESSION['role'])) {
            //redirect based on role
            if ($_SESSION['role'] == "user") {
                header("Location: user-page.php");
            } else if ($_SESSION['role'] == "librarian") {
                header("Location: librarian-page.php");
            } else if ($_SESSION['role'] == "admin") {
                header("Location: admin-page.php");
            }
        } else {
            //Library is open
            if (!empty($_GET['username']) && !empty($_GET['password'])) {
                $username = $_GET['username'];
                $password = $_GET['password'];
                $userDao = new UserDAO();
                $userObj = $userDao->authenticateUser($username, $password);
                var_dump($userObj);
                if ($userObj != null) {
                    //authenticate successful
                    $status = $userObj->getStatus();
                    var_dump($status);
                    if ($status == "new") {
                        //new
                        echo "<h2>Registration Pending. <hr>
                            Please wait for your registration to be approved.
                            ";
                    } else if ($status == "active") {
                        //active
                        $_SESSION['role'] = $userObj->getRole();
                        $_SESSION['username'] = $userObj->getUsername();
                        if ($_SESSION['role'] == "user") {
                            header("Location: user-page.php");
                        } else if ($_SESSION['role'] == "librarian") {
                            header("Location: librarian-page.php");
                        } else if ($_SESSION['role'] == "admin") {
                            header("Location: admin-page.php");
                        }
                    } else if ($status == "inactive") {
                        //incative
                        echo "<h2>Registration Failed. <hr>
                            You are not allowed to use this library.<br>
                            ";
                    }
                } else {
                    //unsuccessful
                    echo "<h2>Authentication Failure. <hr>
                            Please check your username and/or password.<br>
                            If you are not a registered user, please <a href='register.php'>register</a>.";
                }
            } else {
                echo
                "
            <h2>Please Login</h2>
            <form>
                <table border='1'>
                    <tr>
                        <td>User Name:</td>
                        <td><input type='text' name='username'></td>
                    </tr>
                    <tr>
                        <td>Password:</td>
                        <td><input type='password' name='password'></td>
                    </tr>
                    <tr>
                        <td></td>
                        <td><input type='submit' name='submit'></td>
                    </tr>
                </table>
            </form>
        ";
            }
        }
    }


    // Hints/Logic:
    // If the hour of the day outside the opening hours, show a message.
    // Else, if the user is already logged in, redirect the user based on his role.
    // Else, if the login form is not submitted, display the form to login.
    // Else, authenticate the user.
    //    If authentication succeeds, redirect the user based on his role.
    //        Else, if the registration is in inactive mode, ask to get confirmed.
    //        Else, say that registration has been rejected. 
    //    Else, ask the user to get registered.

    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.

    // END OF YOUR CODE
    ?>
</body>

</html>