<?php

/*
    Name: STUDENT SIX
    Email: student.six.2023
*/

require_once "autoload.php";
?>
<html>

<head>
    <title>
        Login to the Library
    </title>
</head>

<body>

    <?php
    date_default_timezone_set("Singapore");
    $hourOfTheDay = 8;

    // To test your code. Comment out before submitting.
    // $hourOfTheDay = 6;

    // ADD YOUR CODE STARTING HERE
    if(isset($_SESSION["username"]) && isset($_SESSION["role"])){
        $role=$_SESSION["role"];
        $url="$role"."-page.php";
        header("Location: $url");
        exit();
    }

    if(isset($_POST["username"]) && isset($_POST["password"])){
        $username=$_POST["username"];
        $password=$_POST["password"];
        $dao=new UserDAO();
        $user=$dao->authenticateUser($username, $password);

        if($user==null){
            $_SESSION["errors"]="<h2>Authentication Failure</h2> Please check your username and/or password. <br> If you are not registered user, please <a href='register.php'>register</a>.";
            header("Location: login.php");
            exit();
        }

        $role=$user->getRole();
        $status=$user->getStatus();

        if($status=="new"){
            $_SESSION["errors"]="<h2>Registration Pending</h2> Please wait for your registration to be approved.<br>";
            header("Location: login.php");
            exit();
        }
        elseif($status=="inactive"){
            $_SESSION["errors"]="<h2>Registration Failed</h2> You are not allowed to use this library.<br>";
            header("Location: login.php");
            exit();
        }
        elseif($status=="active"){
            $_SESSION["username"]=$username;
            $_SESSION["role"]=$role;
            $url="$role"."-page.php";
            header("Location: $url");
            exit();
        }
    }
    // Hints/Logic:
    // If the hour of the day outside the opening hours, show a message.
    // Else, if the user is already logged in, redirect the user based on his role.
    // Else, if the login form is not submitted, display the form to login.
    // Else, authenticate the user.
    //    If authentication succeeds, redirect the user based on his role.
    //        Else, if the registration is in inactive mode, ask to get confirmed.
    //        Else, say that registration has been rejected. 
    //    Else, ask the user to get registered.
    
    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.
        
    // END OF YOUR CODE
    ?>
<?php
    printErrors();
    if($hourOfTheDay>=8 && $hourOfTheDay<=19){
?>
<form action="login.php" method="post">
    <h2>Please Login</h2>
        <table border='1'>
        <tr>
            <td>Username:</td>
            <td> <input name="username" /> </td>
        </tr>
        <tr>
            <td>Password:</td>
            <td> <input type="password" name="password" /> </td>
        </tr>
        <tr>
            <td></td>
            <td> <input type="submit" value="Submit" /> </td>
        </tr>
        </table>
        <br/>
    </form>
<?php
    }
    else{
        echo"<h2>Sorry, the library is closed now.</h2>";
    }
?>
</body>

</html>