<?php

/*
        Name: STUDENT SEVEN
        Email: student.seven.2023
    */

require_once "autoload.php";
?>
<html>

<head>
    <title>
        Login to the Library
    </title>
</head>

<body>

    <?php
    date_default_timezone_set("Singapore");
    $hourOfTheDay = date('H');

    // To test your code. Comment out before submitting.
    $hourOfTheDay = 8;

    // ADD YOUR CODE STARTING HERE
    session_start();
    if ($hourOfTheDay < 8 ||  $hourOfTheDay > 19) {
        $error = '<h2>Sorry, the library is closed now.</h2><hr>';
        echo $error;
    } else { // in operating hrs
        if (isset($_SESSION['username'])) { // logged in 
            if ($_SESSION['username'] == 'user') {
                header("Location: user-page.php");
                exit;
            }
            if ($_SESSION['username'] == 'librarian') {
                header("Location: librarian-page.php");
                exit;
            }
            if ($_SESSION['username'] == 'admin') {
                header("Location: admin-page.php");
                exit;
            }
        } else { //not logged in
            if (!isset($_POST['Submit'])) {
                echo "<h2>Please Login</h2>
        <form method='post'>
        <table border='1'> <tr><td>User Name:</td><td><input type='text' name='username'></td></tr>
        <tr><td>Password:</td><td><input type='password' name='password'></td></tr>
        <tr><td></td><td><input type='submit' name='Submit'></td></tr> 
        </table>";
            } else {
            }
            if (isset($_POST['Submit'])) {
                $username = trim($_POST['username']);
                $password = trim($_POST['password']);

                $dao = new UserDAO();
                // Verify user credentials
                if ($dao->authenticateUser($username, $password)) {
                    // Authentication successful, set session and redirect
                    $_SESSION['username'] = $username;
                    $_SESSION['role'] = $dao->authenticateUser($username, $password)->getRole();
                    if ($_SESSION['role'] == 'user') {
                        if ($dao->authenticateUser($username, $password)->getStatus() == 'new') {
                            $error = "<h2>Registration Pending</h2><hr>Please wait for your registration to be approved.";
                        } elseif ($dao->authenticateUser($username, $password)->getStatus() == 'inactive') {
                            $error = "<h2>Registration Failed</h2><hr>You are not allowed to use this library.";
                        } else {
                            $error = "<h2>Library: User Dashboard</h2><hr><a href='logout.php'>Logout from the Library</a>";
                        }
                    }
                    if ($_SESSION['role'] == 'librarian') {
                        $error = "<h2>Library: Librarian Portal</h2><hr><a href='logout.php'>Logout from the Library</a>";
                    }
                    if ($_SESSION['role'] == 'admin') {
                        $error = "<h2>Library: Administrator Portal</h2><hr><a href='logout.php'>Logout from the Library</a>";
                    }
                } else {
                    // Authentication failed, display error
                    $error = "<h2>Authentication Failure</h2><hr>Please check your username and/or password.
                    <br>If you are not a registered user, please <a href='register.php'>register</a>.";
                }
            }

            if (!empty($error)) {
                echo $error;
            }
        }
    }

    // Hints/Logic:
    // If the hour of the day outside the opening hours, show a message.
    // Else, if the user is already logged in, redirect the user based on his role.
    // Else, if the login form is not submitted, display the form to login.
    // Else, authenticate the user.
    //    If authentication succeeds, redirect the user based on his role.
    //        Else, if the registration is in inactive mode, ask to get confirmed.
    //        Else, say that registration has been rejected. 
    //    Else, ask the user to get registered.

    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.

    // END OF YOUR CODE
    ?>
</body>

</html>