<?php
/*
        Name: STUDENT SEVEN
        Email: student.seven.2023
    */

require_once "autoload.php";
require_once "protect.php";

// Check if user is logged in
if (!isset($_SESSION['username'])) {
    // Redirect or display login form
    header("Location: login.php");
    exit;
}

// Get available books
$dao = new BookDAO();
$books = $dao->getAvailableBooks();
echo"    <h2>Library: User Dashboard</h2>
<a href='logout.php'>Logout from the Library</a>
<br>";
// Process book checkout
if ($_SERVER["REQUEST_METHOD"] === "GET" && isset($_GET['checkedout'])) {
    if (isset($_GET['checkout'])) {
        foreach ($_GET['checkout'] as $book) {
            echo "<h2>$book</h2>"; // Display checked out books
        }
    }
}

?>

<html>
<head>
    <title>User Dashboard</title>
</head>
<body>

    <?php if ($books): ?>
        <h2>Check out some books:</h2>
        <form method="get" action="">
            <table border="1">
                <tr><th>Title</th><th>Author</th><th>Checkout</th></tr>
                <?php foreach ($books as $b): ?>
                    <tr>
                        <td><?= $b->getTitle() ?></td>
                        <td><?= $b->getAuthor() ?></td>
                        <td><input name="checkout[]" type="checkbox" value="<?= $b->getTitle() ?>"></td>
                    </tr>
                <?php endforeach; ?>
                <tr>
                    <td colspan="3"><input type="submit" value="Checkout Selected Books" name="checkedout"></td>
                </tr>
            </table>
        </form>
    <?php endif; ?>
</body>
</html>
