<?php

/*
    Name: Student One
    Email: student.one.2023
*/

require_once "autoload.php";
?>
<html>

<head>
    <title>
        Login to the Library
    </title>
</head>

<body>

    <?php
    date_default_timezone_set("Singapore");
    $hourOfTheDay = date('H');

    // To test your code. Comment out before submitting.
    //$hourOfTheDay = 6;

    // ADD YOUR CODE STARTING HERE

    // Hints/Logic:
    // If the hour of the day outside the opening hours, show a message.
    // Else, if the user is already logged in, redirect the user based on his role.
    // Else, if the login form is not submitted, display the form to login.
    // Else, authenticate the user.
    //    If authentication succeeds, redirect the user based on his role.
    //        Else, if the registration is in inactive mode, ask to get confirmed.
    //        Else, say that registration has been rejected. 
    //    Else, ask the user to get registered.
    if ($hourOfTheDay < 8 || $hourOfTheDay > 19) {
        echo "<h2>Sorry,the library is closed now.</h2>";
    } 
    else {
        if (!isset($_GET["username"])) {
            echo "<h2>Please Login</h2>";
            echo "<form>";
            echo "<table border=1> 
                <tr>
                    <td>User Name:</td>
                    <td><input type='text' name='username'></td>
                </tr>
                <tr> 
                    <td>Password:</td>
                    <td><input type='password' name='password'></td>
                </tr>
                <tr> 
                    <td></td>
                    <td><input type='submit'</td>
            </table>
            </form>";
        } 
        elseif (isset($_GET["username"])) {
            $userDAO = new UserDAO();
            $_SESSION["username"] = $_GET["username"];
            $authenticate = $userDAO->authenticateUser($_GET["username"], $_GET["password"]);
            if ($authenticate == null) {
                echo "<h2>Authentication Failure</h2><hr>";
                echo "Please check your username and/or password.<br>";
                echo "If you are not a registered user, please <a href='register.php'>register</a>";
            }
            else{
                $status = $authenticate -> getStatus();
                if ($status == "new"){
                    echo "<h2>Registration Pending</h2><hr>";
                    echo "Please wait for your registration to be approved.";
                }
                elseif($status == "active"){
                    $role = $authenticate -> getRole();
                    $_SESSION["role"] = $role;
                    if ($role == "user"){
                        header('Location:user-page.php');
                    }
                    elseif($role == "librarian"){
                        header("Location: librarian-page.php");
                    }
                    else{
                        header("Location: admin-page.php");
                    }
                }
                else{
                    echo "<h2>Registration Failed</h2><hr>";
                    echo "You are not allowed to use this library.";
                }
            }
        }
    }

    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.


    // END OF YOUR CODE
    ?>
</body>

</html>