<?php

/*
    Name: STUDENT TEN
    Email: student.ten.2023
*/

require_once "autoload.php";
?>
<html>

<head>
    <title>
        Login to the Library
    </title>
</head>

<body>

    <?php
    date_default_timezone_set("Singapore");
    $hourOfTheDay = date('H');

    // To test your code. Comment out before submitting.
    // $hourOfTheDay = 6;

    // ADD YOUR CODE STARTING HERE

    if ($hourOfTheDay < 8 || $hourOfTheDay > 19) {
        echo "<h2>Sorry, the library is closed now.</h2>";
        echo "<hr>";
    } elseif (isset($_SESSION['username'])) {
        header("Location:{$role}-page.php");
        exit();
    } elseif (!isset($_POST['username']) && !isset($_POST['password'])) {
        echo "<h2>Please Login</h2>";
        echo "<form action='login.php' method = 'post'>";
        echo "<table border='1'>";
        echo "<tr>
                    <td>User Name: </td>
                    <td><input type = 'text' name = 'username'></td>
                </tr>";
        echo "<tr>
                    <td>Password: </td>
                    <td><input type = 'password' name = 'password'></td>
                </tr>";
        echo "<tr>
                    <td></td>
                    <td><input type ='submit'></td>
                </tr>";
        echo "</table>";
        echo "</form>";
    } else {
        $username = $_POST['username'];
        $password = $_POST['password'];

        $userDAO = new UserDAO;
        $authenticate = null;
        $authenticate = $userDAO->authenticateUser($username, $password);

        if ($authenticate) {
            $status = $authenticate->getStatus();

            if ($status == 'active') {

                $role = $authenticate->getRole();
                $username = $authenticate->getUsername();
                $_SESSION["role"] = $role;
                $_SESSION["username"] = $username;
                header("Location: {$role}-page.php");
                exit();
                
            } elseif ($status == 'inactive') {
                echo "<h2>Registration Failed</h2>";
                echo "<hr>";
                echo "You are not allowed to use this library.";
            } elseif ($status == 'new') {
                echo "<h2>Registration Pending</h2>";
                echo "<hr>";
                echo "Please wait for your registration to be approved.";
            }

        } elseif (!$authenticate)
        {
            echo "<h2>Authentication Failure</h2>";
            echo "<hr>";
            echo "<br>Please check your username and/or password.<br>
            If you are not a registered user, please <a href = 'register.php'>register</a>.";
        }
    }




    // Hints/Logic:
    // If the hour of the day outside the opening hours, show a message.
    // Else, if the user is already logged in, redirect the user based on his role.
    // Else, if the login form is not submitted, display the form to login.
    // Else, authenticate the user.
    //    If authentication succeeds, redirect the user based on his role.
    //        Else, if the registration is in inactive mode, ask to get confirmed.
    //        Else, say that registration has been rejected. 
    //    Else, ask the user to get registered.

    // Hints/Display:
    // Use <h2> to create all heading-type displays.
    // <hr> creates a horizontal rule.

    // END OF YOUR CODE
    ?>
</body>

</html>